/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { HorizontalAnchoredCategorySeries } from "./HorizontalAnchoredCategorySeries";
import { IUnknownValuePlotting_$type } from "igniteui-react-core/ES5/IUnknownValuePlotting";
import { CategoryLineRasterizer } from "./CategoryLineRasterizer";
import { UnknownValuePlotting_$type } from "igniteui-react-core/ES5/UnknownValuePlotting";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { Type, typeCast, runOn, enumGetBox, markType } from "igniteui-react-core/ES5/type";
import { Path } from "igniteui-react-core/ES5/Path";
import { ScalerParams } from "./ScalerParams";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { AnchoredCategorySeriesView } from "./AnchoredCategorySeriesView";
import { ISortingAxis_$type } from "./ISortingAxis";
import { Color } from "igniteui-react-core/ES5/Color";
var LineSeries = /** @class */ (function (_super) {
    tslib_1.__extends(LineSeries, _super);
    function LineSeries() {
        var _this = _super.call(this) || this;
        _this.p6 = null;
        _this.p6 = new CategoryLineRasterizer();
        _this.ab = LineSeries.$;
        _this.pq = 0;
        return _this;
    }
    LineSeries.prototype.bf = function () {
        return new LineSeriesView(this);
    };
    LineSeries.prototype.ii = function (a) {
        _super.prototype.ii.call(this, a);
        this.p7 = a;
    };
    LineSeries.prototype.get_cj = function () {
        return true;
    };
    Object.defineProperty(LineSeries.prototype, "cj", {
        get: function () {
            return this.get_cj();
        },
        enumerable: true,
        configurable: true
    });
    LineSeries.prototype.preferredCategoryMode = function (a) {
        return this.pq;
    };
    LineSeries.prototype.hl = function (a, b) {
        _super.prototype.hl.call(this, a, b);
        var c = b;
        c.c5();
    };
    LineSeries.prototype.ob = function (a, b) {
        _super.prototype.ob.call(this, a, b);
        var c = b.cl.d;
        var d = typeCast(LineSeriesView.$, b);
        var e = a.f;
        var f = this.getEffectiveViewport1(b);
        this.m2.x(this, this.nn(), this.pn, runOn(this, this.mo), this.nv(b), this.nw(b));
        var g = false;
        var h = this.m2.c;
        if (h != null) {
            g = true;
        }
        if (g) {
            var i = new ScalerParams(0, b.bq, b.bp, this.pn.b8, f);
            this.n7(e, -1, this.valueColumn.count, this.pn, i, b.n);
        }
        var j = d.db;
        var k = d.dc;
        var l = d.da;
        this.m2.ae(j, true, false, true, false);
        this.m2.ae(k, true, false, true, false);
        this.m2.ae(l, false, true, false, false);
        l._opacity = 0.75 * this.m2.i;
        if (b.cp(a)) {
            d.c6(e.count, e, true, this.unknownValuePlotting, this.ol(e, e.count - 1, b.bp, b.bq), c, this.eo);
            b.cs(a);
        }
    };
    LineSeries.prototype.io = function (a, b, c, d) {
        _super.prototype.io.call(this, a, b, c, d);
        switch (b) {
            case LineSeries.$$p[0]:
                this.mz.m = this.unknownValuePlotting == 0;
                this.i1(false);
                this.h8();
                break;
        }
    };
    Object.defineProperty(LineSeries.prototype, "useHighMarkerFidelity", {
        get: function () {
            return this.nq;
        },
        enumerable: true,
        configurable: true
    });
    LineSeries.$t = markType(LineSeries, 'LineSeries', HorizontalAnchoredCategorySeries.$, [IUnknownValuePlotting_$type]);
    return LineSeries;
}(HorizontalAnchoredCategorySeries));
export { LineSeries };
Type.dep(DependencyProperty, PropertyMetadata, LineSeries, 'raisePropertyChanged', ['UnknownValuePlotting::p9', [UnknownValuePlotting_$type, enumGetBox(UnknownValuePlotting_$type, 1)]]);
var LineSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(LineSeriesView, _super);
    function LineSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.c4 = null;
        _this.de = new Path();
        _this.dd = new Path();
        _this.df = new Path();
        _this.c9 = new Path();
        _this.c8 = new Path();
        _this.c7 = new Path();
        _this.c4 = a;
        return _this;
    }
    Object.defineProperty(LineSeriesView.prototype, "db", {
        get: function () {
            return this.de;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "dc", {
        get: function () {
            return this.df;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LineSeriesView.prototype, "da", {
        get: function () {
            return this.dd;
        },
        enumerable: true,
        configurable: true
    });
    LineSeriesView.prototype.c5 = function () {
        this.dd.aj = null;
        this.de.aj = null;
        this.df.aj = null;
        this.an();
    };
    LineSeriesView.prototype.c6 = function (a, b, c, d, e, f, g) {
        this.c4.p6.a = typeCast(ISortingAxis_$type, this.cn.fetchXAxis()) !== null ? true : false;
        this.c4.p6.m(this.de, this.dd, this.df, a, b, c, d, e, f, g);
        this.an();
    };
    LineSeriesView.prototype.a8 = function () {
        _super.prototype.a8.call(this);
    };
    LineSeriesView.prototype.a9 = function () {
        _super.prototype.a9.call(this);
        this.c8.aj = this.de.aj;
        this.c9.aj = this.df.aj;
        this.c7.aj = this.dd.aj;
        var a = this.bk();
        this.c8._stroke = a;
        this.c8.ac = this.e.es + 3;
        this.c9._stroke = a;
        this.c9.ac = this.e.es + 3;
        this.c7._fill = a;
        this.c7._opacity = 1;
    };
    LineSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (a.d) {
            if (b) {
                a.s(this.c7);
                a.s(this.c8);
                a.s(this.c9);
            }
            else {
                a.s(this.dd);
                a.s(this.de);
                a.s(this.df);
            }
        }
    };
    LineSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        this.e.a2.exportPathData(a, this.de, "lowerShape", ["Lower", "Main"]);
        this.e.a2.exportPathData(a, this.df, "upperShape", ["Upper"]);
        this.e.a2.exportPathData(a, this.dd, "translucentShape", ["Translucent"]);
    };
    LineSeriesView.prototype.ac = function () {
        var a = new Color();
        a.colorString = "rgba(95,95,95,0.5)";
        this.e.ky = a;
        this.e.ep = 3;
        this.e.eq = 1;
        this.e.er = 4;
        this.e.dr = false;
    };
    LineSeriesView.$t = markType(LineSeriesView, 'LineSeriesView', AnchoredCategorySeriesView.$);
    return LineSeriesView;
}(AnchoredCategorySeriesView));
export { LineSeriesView };
/*<BeginStatics Name="Infragistics.Controls.Charts.LineSeries" />*/
/*<EndStatics Name="Infragistics.Controls.Charts.LineSeries" />*/
